library ac_dart.descriptor_model.bitbucket;

import 'package:atlassian_connect_host/src/json_utils.dart';
import 'package:atlassian_connect_host/src/descriptor/descriptor_model.dart';

class BitbucketConnectAddon extends ConnectAddon<BitbucketModuleList> {}

class BitbucketModuleList extends CoreModuleList {
  final Iterable<Page> repoPage;

  BitbucketModuleList(
      {Iterable<WebItem> webItems: const [], Page configurePage, this.repoPage})
      : super(webItems: webItems, configurePage: configurePage);

  factory BitbucketModuleList.fromJson(Map json) {
    final p = parseJson(json);
    return new BitbucketModuleList(
        repoPage: p.list('repoPage', (v) => new Page.fromJson(v)),
        webItems: p.list('webItem', (v) => new WebItem.fromJson(v)),
        configurePage: p.single('configurePage', (v) => new Page.fromJson(v)));
  }

  Map toJson() => (buildJson
    ..addAll(super.toJson())
    ..add('repoPage', repoPage)).json;
}
